/*
 * sample.c: To see if the macros defined in xpf_user.h work.
 */

#include <stdio.h>
#include "xpf.h"

/*
 * Has one pattern with a fixed size header of len=24, matches two filters
 * and has one attached program. It does not delay messages and has alarm=1
 * (destroy old program when new one is about to be created).
 */
main()
{
	XPFFilter	f1, f2;
	XPFProgram	r;
	XPFPattern	p;
	XPFVariableHeader v;

	xpfInitializeSelector(&(f1.extractor.selector), 0, 0, 4);
	xpfInitializeExtractor(&(f1.extractor), XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(&f1, 12345678, NULL);

	xpfInitializeSelector(&(f2.extractor.selector), 1, 0, 4);
	xpfInitializeExtractor(&(f2.extractor), XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(&f2, 87654321, &f1);

	xpfInitializeSelector(&(r.extractor.selector), 4, 0, 4);
	xpfInitializeExtractor(&(r.extractor), XPF_DATA_SHORT, 0xffff);
	xpfInitializeProgram(&r, NULL);

	/* xpfInitializeFixedHeader(&p.header, 24); */
	xpfInitializeVariableHeader(&p.header, &v, 2, 4, XPF_DATA_SHORT, 0xffff, 2);
	xpfInitializePattern(&p, &f2, &r, 0, 1, NULL);

	xpfPrintPatternList(&p);
	printf("\n");
}
